package me.flashyreese.mods.sodiumextra.mixin.animation;

import me.flashyreese.mods.sodiumextra.client.SodiumExtraClientMod;
import net.minecraft.class_1044;
import net.minecraft.class_1058;
import net.minecraft.class_1059;
import net.minecraft.class_1061;
import net.minecraft.class_2960;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Redirect;

@Mixin(class_1059.class)
public abstract class MixinSpriteAtlasTexture extends class_1044 {
    
    @Redirect(method = "upload", at = @At(value = "INVOKE", target = "Lnet/minecraft/client/texture/Sprite;getAnimation()Lnet/minecraft/client/texture/TextureTickListener;"))
    public class_1061 sodiumExtra$tickAnimatedSprites(class_1058 instance) {
        if (instance.method_33443() != null && SodiumExtraClientMod.options().animationSettings.animation && this.shouldAnimate(instance.method_4598()))
            return instance.method_33443();
        return null;
    }

    private boolean shouldAnimate(class_2960 identifier) {
        if (identifier != null) {
            String path = identifier.method_12832();
            if (path.endsWith("water_still") || path.endsWith("water_flow")) {
                return SodiumExtraClientMod.options().animationSettings.water;
            } else if (path.endsWith("lava_still") || path.endsWith("lava_flow")) {
                return SodiumExtraClientMod.options().animationSettings.lava;
            } else if (path.endsWith("nether_portal")) {
                return SodiumExtraClientMod.options().animationSettings.portal;
            } else if (path.endsWith("fire_0") || path.endsWith("fire_1") || path.endsWith("soul_fire_0") ||
                    path.endsWith("soul_fire_1") || path.endsWith("campfire_fire") || path.endsWith("campfire_log_lit") ||
                    path.endsWith("soul_campfire_fire") || path.endsWith("soul_campfire_log_lit")) {
                return SodiumExtraClientMod.options().animationSettings.fire;
            } else if (path.endsWith("magma") || path.endsWith("lantern") || path.endsWith("sea_lantern") ||
                    path.endsWith("soul_lantern") || path.endsWith("kelp") || path.endsWith("kelp_plant") ||
                    path.endsWith("seagrass") || path.endsWith("warped_stem") || path.endsWith("crimson_stem") ||
                    path.endsWith("blast_furnace_front_on") || path.endsWith("smoker_front_on") ||
                    path.endsWith("stonecutter_saw")) {
                return SodiumExtraClientMod.options().animationSettings.blockAnimations;
            } else if (path.endsWith("sculk_sensor_tendril_inactive") || path.endsWith("sculk_sensor_tendril_active") ||
                    path.endsWith("particle/vibration")) {
                return SodiumExtraClientMod.options().animationSettings.sculkSensor;
            }
        }
        return true;
    }
}
